from itemadapter import ItemAdapter
import pymysql,requests

class LhhPipeline:

    def __init__(self):
        self.connection = pymysql.connect(
                    host='127.0.0.1',
                    user='root',
                    password='',
                    db='lhh',
                    charset='utf8mb4',
                )
        self.cursor = self.connection.cursor()

        bank_api = 'https://lianhanghao.com/api/bank/bankList'
        r = requests.post(bank_api)
        bank_list = r.json()['data']
        for bank in bank_list:
            columns = ','.join(bank.keys())
            values = self.format_values(bank)
            insert_sql = "INSERT INTO bankdata({}) VALUES({})".format(columns, values)
            self.cursor.execute(insert_sql)
            self.connection.commit()

        city_api = 'https://lianhanghao.com/api/area/cityList'
        r = requests.post(city_api)
        city_list = r.json()['data']
        for city in city_list:
            columns = ','.join(city.keys())
            values = self.format_values(city)
            insert_sql = "INSERT INTO citydata({}) VALUES({})".format(columns, values)
            self.cursor.execute(insert_sql)
            self.connection.commit()

    def format_values(self,item):
        li = []
        for value in item.values():
            if value =='':
                li.append('NULL')
            elif type(value)==str:
                value = value.replace('\"','')
                li.append('\"{}\"'.format(value))
            else:
                li.append(value)
        return ','.join([str(x) for x in li])

    def process_item(self, item, spider):
        columns = ','.join(item.keys())
        values = self.format_values(item)
        insert_sql = "INSERT INTO lhhdata({}) VALUES({})".format(columns, values)
        self.cursor.execute(insert_sql)
        self.connection.commit()
        return item

