import scrapy
from lhh.items import LhhItem

class LhhdataSpider(scrapy.Spider):
    name = 'lhhdata'
    allowed_domains = ['http://www.lianhanghao.com/']
    api = 'http://www.lianhanghao.com/api/bank/lhhTableData'

    def start_requests(self):
        formdata = {"current":'1',
                    "size":"20",
                    "bank_id":"",
                    "province_id":"",
                    "city_id":"",
                    "keywords":""}
        yield scrapy.FormRequest(self.api,formdata=formdata,callback=self.get_total)


    def get_total(self, response):
        total_page = int(response.json()['data']['total_num']/100)+1
        for page in range(total_page):
            formdata = {"current":str(page),
                "size":"100",
                "bank_id":"",
                "province_id":"",
                "city_id":"",
                "keywords":""}
            yield scrapy.FormRequest(self.api,formdata=formdata,callback=self.get_one_page,dont_filter=True)


    def get_one_page(self, response):
        data = response.json()['data']['data']
        for d in data:
            item = LhhItem(id=d['id'],area_pid=d['area_pid'],area_id=d['area_id'],
                        bankname=d['bankname'],hanghao=d['hanghao'],bank_id=d['bank_id'],
                        tel=d['tel'],address=d['address'],create_time=d['create_time'])
            yield item






